# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class HookActionHTTP(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, endpoint: str=None, verb: str=None, params: str=None, body: object=None):  # noqa: E501
        """HookActionHTTP - a model defined in Swagger

        :param endpoint: The endpoint of this HookActionHTTP.  # noqa: E501
        :type endpoint: str
        :param verb: The verb of this HookActionHTTP.  # noqa: E501
        :type verb: str
        :param params: The params of this HookActionHTTP.  # noqa: E501
        :type params: str
        :param body: The body of this HookActionHTTP.  # noqa: E501
        :type body: object
        """
        self.swagger_types = {
            'endpoint': str,
            'verb': str,
            'params': str,
            'body': object
        }

        self.attribute_map = {
            'endpoint': 'endpoint',
            'verb': 'verb',
            'params': 'params',
            'body': 'body'
        }

        self._endpoint = endpoint
        self._verb = verb
        self._params = params
        self._body = body

    @classmethod
    def from_dict(cls, dikt) -> 'HookActionHTTP':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The HookActionHTTP of this HookActionHTTP.  # noqa: E501
        :rtype: HookActionHTTP
        """
        return util.deserialize_model(dikt, cls)

    @property
    def endpoint(self) -> str:
        """Gets the endpoint of this HookActionHTTP.


        :return: The endpoint of this HookActionHTTP.
        :rtype: str
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint: str):
        """Sets the endpoint of this HookActionHTTP.


        :param endpoint: The endpoint of this HookActionHTTP.
        :type endpoint: str
        """

        self._endpoint = endpoint

    @property
    def verb(self) -> str:
        """Gets the verb of this HookActionHTTP.


        :return: The verb of this HookActionHTTP.
        :rtype: str
        """
        return self._verb

    @verb.setter
    def verb(self, verb: str):
        """Sets the verb of this HookActionHTTP.


        :param verb: The verb of this HookActionHTTP.
        :type verb: str
        """

        self._verb = verb

    @property
    def params(self) -> str:
        """Gets the params of this HookActionHTTP.


        :return: The params of this HookActionHTTP.
        :rtype: str
        """
        return self._params

    @params.setter
    def params(self, params: str):
        """Sets the params of this HookActionHTTP.


        :param params: The params of this HookActionHTTP.
        :type params: str
        """

        self._params = params

    @property
    def body(self) -> object:
        """Gets the body of this HookActionHTTP.


        :return: The body of this HookActionHTTP.
        :rtype: object
        """
        return self._body

    @body.setter
    def body(self, body: object):
        """Sets the body of this HookActionHTTP.


        :param body: The body of this HookActionHTTP.
        :type body: object
        """

        self._body = body
